--- a/drivers/ide/ide-tape.c
+++ b/drivers/ide/ide-tape.c
@@ -443,6 +443,7 @@
 #include <linux/smp_lock.h>
 #include <linux/completion.h>
 #include <linux/bitops.h>
+#include <linux/jiffies.h>
 
 #include <asm/byteorder.h>
 #include <asm/irq.h>
@@ -2335,7 +2336,7 @@ static ide_startstop_t idetape_rw_callba
 	}
 	if (time_after(jiffies, tape->insert_time))
 		tape->insert_speed = tape->insert_size / 1024 * HZ / (jiffies - tape->insert_time);
-	if (jiffies - tape->avg_time >= HZ) {
+	if (time_after_eq(jiffies, tape->avg_time + HZ)) {
 		tape->avg_speed = tape->avg_size * HZ / (jiffies - tape->avg_time) / 1024;
 		tape->avg_size = 0;
 		tape->avg_time = jiffies;
@@ -2496,7 +2497,7 @@ static ide_startstop_t idetape_do_reques
 			} else {
 				return ide_do_reset(drive);
 			}
-		} else if (jiffies - tape->dsc_polling_start > IDETAPE_DSC_MA_THRESHOLD)
+		} else if (time_after(jiffies, tape->dsc_polling_start + IDETAPE_DSC_MA_THRESHOLD))
 			tape->dsc_polling_frequency = IDETAPE_DSC_MA_SLOW;
 		idetape_postpone_request(drive);
 		return ide_stopped;
--- a/drivers/ide/ide.c
+++ b/drivers/ide/ide.c
@@ -1428,8 +1428,6 @@ static int __init stridx (const char *s,
  */
 static int __init match_parm (char *s, const char *keywords[], int vals[], int max_vals)
 {
-	static const char *decimal = "0123456789";
-	static const char *hex = "0123456789abcdef";
 	int i, n;
 
 	if (*s++ == '=') {
@@ -1449,12 +1447,12 @@ static int __init match_parm (char *s, c
 		 * or base16 when prefixed with "0x".
 		 * Return a count of how many were found.
 		 */
-		for (n = 0; (i = stridx(decimal, *s)) >= 0;) {
+		for (n = 0; (i = stridx(small_digits, *s)) >= 0;) {
 			vals[n] = i;
-			while ((i = stridx(decimal, *++s)) >= 0)
+			while ((i = stridx(small_digits, *++s)) >= 0)
 				vals[n] = (vals[n] * 10) + i;
 			if (*s == 'x' && !vals[n]) {
-				while ((i = stridx(hex, *++s)) >= 0)
+				while ((i = stridx(small_digits, *++s)) >= 0)
 					vals[n] = (vals[n] * 0x10) + i;
 			}
 			if (++n == max_vals)
--- a/drivers/ide/legacy/hd.c
+++ b/drivers/ide/legacy/hd.c
@@ -456,11 +456,6 @@ ok_to_read:
 	req->errors = 0;
 	i = --req->nr_sectors;
 	--req->current_nr_sectors;
-#ifdef DEBUG
-	printk("%s: read: sector %ld, remaining = %ld, buffer=%p\n",
-		req->rq_disk->disk_name, req->sector, req->nr_sectors,
-		req->buffer+512));
-#endif
 	if (req->current_nr_sectors <= 0)
 		end_request(req, 1);
 	if (i > 0) {
@@ -542,12 +537,8 @@ static void hd_times_out(unsigned long d
 	reset = 1;
 	name = CURRENT->rq_disk->disk_name;
 	printk("%s: timeout\n", name);
-	if (++CURRENT->errors >= MAX_ERRORS) {
-#ifdef DEBUG
-		printk("%s: too many errors\n", name);
-#endif
+	if (++CURRENT->errors >= MAX_ERRORS)
 		end_request(CURRENT, 0);
-	}
 	local_irq_disable();
 	hd_request();
 	enable_irq(HD_IRQ);
@@ -621,11 +612,6 @@ repeat:
 	track = block / disk->sect;
 	head  = track % disk->head;
 	cyl   = track / disk->head;
-#ifdef DEBUG
-	printk("%s: %sing: CHS=%d/%d/%d, sectors=%d, buffer=%p\n",
-		req->rq_disk->disk_name, (req->cmd == READ)?"read":"writ",
-		cyl, head, sec, nsect, req->buffer);
-#endif
 	if (req->flags & REQ_CMD) {
 		switch (rq_data_dir(req)) {
 		case READ:
--- a/drivers/infiniband/hw/mthca/mthca_reset.c
+++ b/drivers/infiniband/hw/mthca/mthca_reset.c
@@ -153,9 +153,10 @@ int mthca_reset(struct mthca_dev *mdev)
 	/* Now wait for PCI device to start responding again */
 	{
 		u32 v;
-		int c = 0;
+		unsigned long end_time;
 
-		for (c = 0; c < 100; ++c) {
+		end_time = jiffies + msecs_to_jiffies(10000);
+		while (time_before(jiffies, end_time)) {
 			if (pci_read_config_dword(bridge ? bridge : mdev->pdev, 0, &v)) {
 				err = -ENODEV;
 				mthca_err(mdev, "Couldn't access HCA after reset, "
--- a/drivers/input/joystick/analog.c
+++ b/drivers/input/joystick/analog.c
@@ -576,6 +576,7 @@ static int analog_init_masks(struct anal
 static int analog_init_port(struct gameport *gameport, struct gameport_driver *drv, struct analog_port *port)
 {
 	int i, t, u, v;
+	unsigned long end_time;
 
 	port->gameport = gameport;
 
@@ -591,7 +592,8 @@ static int analog_init_port(struct gamep
 		port->mask = (gameport_read(gameport) ^ t) & t & 0xf;
 		port->fuzz = (port->speed * ANALOG_FUZZ_MAGIC) / port->loop / 1000 + ANALOG_FUZZ_BITS;
 
-		for (i = 0; i < ANALOG_INIT_RETRIES; i++) {
+		end_time = jiffies + msecs_to_jiffies(ANALOG_MAX_TIME * ANALOG_INIT_RETRIES);
+		while (time_before(jiffies, end_time)) {
 			if (!analog_cooked_read(port))
 				break;
 			msleep(ANALOG_MAX_TIME);
--- a/drivers/input/keyboard/atkbd.c
+++ b/drivers/input/keyboard/atkbd.c
@@ -149,7 +149,7 @@ static unsigned char atkbd_unxlate_table
 #define ATKBD_RET_EMUL0		0xe0
 #define ATKBD_RET_EMUL1		0xe1
 #define ATKBD_RET_RELEASE	0xf0
-#define ATKBD_RET_HANGUEL	0xf1
+#define ATKBD_RET_HANGEUL	0xf1
 #define ATKBD_RET_HANJA		0xf2
 #define ATKBD_RET_ERR		0xff
 
@@ -303,7 +303,7 @@ static irqreturn_t atkbd_interrupt(struc
 
 		if (atkbd->emul ||
 		    !(code == ATKBD_RET_EMUL0 || code == ATKBD_RET_EMUL1 ||
-		      code == ATKBD_RET_HANGUEL || code == ATKBD_RET_HANJA ||
+		      code == ATKBD_RET_HANGEUL || code == ATKBD_RET_HANJA ||
 		     (code == ATKBD_RET_ERR && !atkbd->err_xl) ||
 	             (code == ATKBD_RET_BAT && !atkbd->bat_xl))) {
 			atkbd->release = code >> 7;
@@ -332,8 +332,8 @@ static irqreturn_t atkbd_interrupt(struc
 		case ATKBD_RET_RELEASE:
 			atkbd->release = 1;
 			goto out;
-		case ATKBD_RET_HANGUEL:
-			atkbd_report_key(atkbd->dev, regs, KEY_HANGUEL, 3);
+		case ATKBD_RET_HANGEUL:
+			atkbd_report_key(atkbd->dev, regs, KEY_HANGEUL, 3);
 			goto out;
 		case ATKBD_RET_HANJA:
 			atkbd_report_key(atkbd->dev, regs, KEY_HANJA, 3);
--- a/drivers/input/misc/hp_sdc_rtc.c
+++ b/drivers/input/misc/hp_sdc_rtc.c
@@ -690,14 +690,24 @@ static struct miscdevice hp_sdc_rtc_dev 
 static int __init hp_sdc_rtc_init(void)
 {
 	int ret;
+	struct proc_dir_entry* proc_de;
 
 	init_MUTEX(&i8042tregs);
 
 	if ((ret = hp_sdc_request_timer_irq(&hp_sdc_rtc_isr)))
 		return ret;
-	misc_register(&hp_sdc_rtc_dev);
-        create_proc_read_entry ("driver/rtc", 0, 0, 
+	ret = misc_register(&hp_sdc_rtc_dev);
+	if (ret) {
+		printk(KERN_WARNING "hp_sdc_rtc: "
+				"Unable to register misc device.\n");
+		return ret;
+	}
+	proc_de = create_proc_read_entry("driver/rtc", 0, 0,
 				hp_sdc_rtc_read_proc, NULL);
+	if (proc_de == NULL) {
+		printk(KERN_WARNING "hp_sdc_rtc: "
+				"Unable to create proc dir entry.\n");
+	}
 
 	printk(KERN_INFO "HP i8042 SDC + MSM-58321 RTC support loaded "
 			 "(RTC v " RTC_VERSION ")\n");
--- a/drivers/isdn/capi/capi.c
+++ b/drivers/isdn/capi/capi.c
@@ -674,13 +674,8 @@ capi_read(struct file *file, char __user
 		if (file->f_flags & O_NONBLOCK)
 			return -EAGAIN;
 
-		for (;;) {
-			interruptible_sleep_on(&cdev->recvwait);
-			if ((skb = skb_dequeue(&cdev->recvqueue)) != 0)
-				break;
-			if (signal_pending(current))
-				break;
-		}
+		wait_event_interruptible(cdev->recvwait,
+				((skb = skb_dequeue(&cdev->recvqueue)) == 0));
 		if (skb == 0)
 			return -ERESTARTNOHAND;
 	}
--- a/drivers/isdn/hardware/eicon/debug.c
+++ b/drivers/isdn/hardware/eicon/debug.c
@@ -756,14 +756,14 @@ int diva_get_driver_info (dword id, byte
 
     data_length -= 9;
 
-    if ((to_copy = MIN(strlen(clients[id].drvName), data_length-1))) {
+    if ((to_copy = min(strlen(clients[id].drvName), data_length-1))) {
       memcpy (p, clients[id].drvName, to_copy);
       p += to_copy;
       data_length -= to_copy;
       if ((data_length >= 4) && clients[id].hDbg->drvTag[0]) {
         *p++ = '(';
         data_length -= 1;
-        if ((to_copy = MIN(strlen(clients[id].hDbg->drvTag), data_length-2))) {
+        if ((to_copy = min(strlen(clients[id].hDbg->drvTag), data_length-2))) {
           memcpy (p, clients[id].hDbg->drvTag, to_copy);
           p += to_copy;
           data_length -= to_copy;
--- a/drivers/isdn/hardware/eicon/io.c
+++ b/drivers/isdn/hardware/eicon/io.c
@@ -262,7 +262,7 @@ void request(PISDN_ADAPTER IoAdapter, EN
     case IDI_SYNC_REQ_XDI_GET_CAPI_PARAMS: {
        diva_xdi_get_capi_parameters_t prms, *pI = &syncReq->xdi_capi_prms.info;
        memset (&prms, 0x00, sizeof(prms));
-       prms.structure_length = MIN(sizeof(prms), pI->structure_length);
+       prms.structure_length = min(sizeof(prms), pI->structure_length);
        memset (pI, 0x00, pI->structure_length);
        prms.flag_dynamic_l1_down    = (IoAdapter->capi_cfg.cfg_1 & \
          DIVA_XDI_CAPI_CFG_1_DYNAMIC_L1_ON) ? 1 : 0;
--- a/drivers/isdn/hisax/diva.c
+++ b/drivers/isdn/hisax/diva.c
@@ -1101,6 +1101,7 @@ setup_diva(struct IsdnCard *card)
 			bytecnt = 32;
 		}
 	}
+	goto ready; /* Assure that `ready' is used even if `__ISAPNP__' isn't. */
 ready:
 	printk(KERN_INFO
 		"Diva: %s card configured at %#lx IRQ %d\n",
--- a/drivers/isdn/hisax/hisax_fcpcipnp.c
+++ b/drivers/isdn/hisax/hisax_fcpcipnp.c
@@ -1000,18 +1000,16 @@ static int __init hisax_fcpcipnp_init(vo
 	printk(KERN_INFO "hisax_fcpcipnp: Fritz!Card PCI/PCIv2/PnP ISDN driver v0.0.1\n");
 
 	retval = pci_register_driver(&fcpci_driver);
-	if (retval)
-		goto out;
+	if (! retval)
+	{
 #ifdef __ISAPNP__
-	retval = pnp_register_driver(&fcpnp_driver);
-	if (retval < 0)
-		goto out_unregister_pci;
+		retval = pnp_register_driver(&fcpnp_driver);
+		if (retval < 0)
+			pci_unregister_driver(&fcpci_driver);
+		else
 #endif
-	return 0;
-
- out_unregister_pci:
-	pci_unregister_driver(&fcpci_driver);
- out:
+			retval = 0;
+	}
 	return retval;
 }
 
--- a/drivers/isdn/hysdn/boardergo.c
+++ b/drivers/isdn/hysdn/boardergo.c
@@ -329,14 +329,16 @@ static int
 ergo_waitpofready(struct HYSDN_CARD *card)
 {
 	tErgDpram *dpr = card->dpram;	/* pointer to DPRAM structure */
-	int timecnt = 10000 / 50;	/* timeout is 10 secs max. */
+	unsigned long end_time;
 	ulong flags;
 	int msg_size;
 	int i;
 
 	if (card->debug_flags & LOG_POF_CARD)
 		hysdn_addlog(card, "ERGO: waiting for pof ready");
-	while (timecnt--) {
+
+	end_time = jiffies + msecs_to_jiffies(10000); /* timeout is 10 secs max. */
+	while (time_before(jiffies, end_time)) {
 		/* wait until timeout  */
 
 		if (dpr->ToPcFlag) {
--- a/drivers/isdn/i4l/isdn_common.c
+++ b/drivers/isdn/i4l/isdn_common.c
@@ -18,6 +18,7 @@
 #include <linux/vmalloc.h>
 #include <linux/isdn.h>
 #include <linux/smp_lock.h>
+#include <linux/wait.h>
 #include "isdn_common.h"
 #include "isdn_tty.h"
 #include "isdn_net.h"
@@ -1177,8 +1178,8 @@ isdn_write(struct file *file, const char
 			goto out;
 		}
 		chidx = isdn_minor2chan(minor);
-		while (isdn_writebuf_stub(drvidx, chidx, buf, count) != count)
-			interruptible_sleep_on(&dev->drv[drvidx]->snd_waitq[chidx]);
+		wait_event(dev->drv[drvidx]->snd_waitq[chidx],
+				(isdn_writebuf_stub(drvidx, chidx, buf, count) == count));
 		retval = count;
 		goto out;
 	}
--- a/drivers/isdn/i4l/isdn_tty.c
+++ b/drivers/isdn/i4l/isdn_tty.c
@@ -1500,8 +1500,8 @@ isdn_tty_block_til_ready(struct tty_stru
 	 */
 	if (tty_hung_up_p(filp) ||
 	    (info->flags & ISDN_ASYNC_CLOSING)) {
-		if (info->flags & ISDN_ASYNC_CLOSING)
-			interruptible_sleep_on(&info->close_wait);
+		wait_event_interruptible(info->close_wait,
+			(info->flags & ISDN_ASYNC_CLOSING)==0);
 #ifdef MODEM_DO_RESTART
 		if (info->flags & ISDN_ASYNC_HUP_NOTIFY)
 			return -EAGAIN;
--- a/drivers/isdn/isdnloop/isdnloop.c
+++ b/drivers/isdn/isdnloop/isdnloop.c
@@ -1294,7 +1294,7 @@ isdnloop_command(isdn_ctrl * c, isdnloop
 							c->parm.num[0] ? "N" : "ALL", c->parm.num);
 					} else
 						sprintf(cbuf, "%02d;EAZ%s\n", (int) a,
-							c->parm.num[0] ? c->parm.num : (u_char *) "0123456789");
+							c->parm.num[0] ? c->parm.num : decimal);
 					i = isdnloop_writecmd(cbuf, strlen(cbuf), 0, card);
 				}
 				break;
--- a/drivers/isdn/sc/ioctl.c
+++ b/drivers/isdn/sc/ioctl.c
@@ -71,14 +71,14 @@ int sc_ioctl(int card, scs_ioctl *data)
 		/*
 		 * Get the SRec from user space
 		 */
-		if (copy_from_user(srec, data->dataptr, sizeof(srec))) {
+		if (copy_from_user(srec, data->dataptr, SCIOC_SRECSIZE)) {
 			kfree(rcvmsg);
 			kfree(srec);
 			return -EFAULT;
 		}
 
 		status = send_and_receive(card, CMPID, cmReqType2, cmReqClass0, cmReqLoadProc,
-				0, sizeof(srec), srec, rcvmsg, SAR_TIMEOUT);
+				0, SCIOC_SRECSIZE, srec, rcvmsg, SAR_TIMEOUT);
 		kfree(rcvmsg);
 		kfree(srec);
 
--- a/drivers/macintosh/adbhid.c
+++ b/drivers/macintosh/adbhid.c
@@ -179,7 +179,7 @@ u8 adb_to_linux_keycodes[128] = {
 	/* 0x65 */ KEY_F9,		/*  67 */
 	/* 0x66 */ KEY_HANJA,		/* 123 */
 	/* 0x67 */ KEY_F11,		/*  87 */
-	/* 0x68 */ KEY_HANGUEL,		/* 122 */
+	/* 0x68 */ KEY_HANGEUL,		/* 122 */
 	/* 0x69 */ KEY_SYSRQ,		/*  99 */
 	/* 0x6a */ 0,
 	/* 0x6b */ KEY_SCROLLLOCK,	/*  70 */
--- a/drivers/macintosh/apm_emu.c
+++ b/drivers/macintosh/apm_emu.c
@@ -520,6 +520,7 @@ static struct miscdevice apm_device = {
 static int __init apm_emu_init(void)
 {
 	struct proc_dir_entry *apm_proc;
+	int rc;
 
 	if (sys_ctrler != SYS_CTRLER_PMU) {
 		printk(KERN_INFO "apm_emu: Requires a machine with a PMU.\n");
@@ -530,7 +531,12 @@ static int __init apm_emu_init(void)
 	if (apm_proc)
 		apm_proc->owner = THIS_MODULE;
 
-	misc_register(&apm_device);
+	rc = misc_register(&apm_device);
+	if (rc < 0) {
+		remove_proc_entry("apm", NULL);
+		printk(KERN_ERR "apm_emu: Failed to register APM Emulation.\n");
+		return rc;
+	}
 
 	pmu_register_sleep_notifier(&apm_sleep_notifier);
 
--- a/drivers/macintosh/via-pmu.c
+++ b/drivers/macintosh/via-pmu.c
@@ -1813,8 +1813,7 @@ pmu_register_sleep_notifier(struct pmu_s
 	struct list_head *list;
 	struct pmu_sleep_notifier *notifier;
 
-	for (list = sleep_notifiers.next; list != &sleep_notifiers;
-	     list = list->next) {
+	list_for_each(list, &sleep_notifiers) {
 		notifier = list_entry(list, struct pmu_sleep_notifier, list);
 		if (n->priority > notifier->priority)
 			break;
@@ -1846,8 +1845,7 @@ broadcast_sleep(int when, int fallback)
 	struct list_head *list;
 	struct pmu_sleep_notifier *notifier;
 
-	for (list = sleep_notifiers.prev; list != &sleep_notifiers;
-	     list = list->prev) {
+	list_for_each_prev(list, &sleep_notifiers) {
 		notifier = list_entry(list, struct pmu_sleep_notifier, list);
 		ret = notifier->notifier_call(notifier, when);
 		if (ret != PBOOK_SLEEP_OK) {
@@ -1868,14 +1866,10 @@ static int
 broadcast_wake(void)
 {
 	int ret = PBOOK_SLEEP_OK;
-	struct list_head *list;
 	struct pmu_sleep_notifier *notifier;
 
-	for (list = sleep_notifiers.next; list != &sleep_notifiers;
-	     list = list->next) {
-		notifier = list_entry(list, struct pmu_sleep_notifier, list);
+	list_for_each_entry(notifier, &sleep_notifiers, list)
 		notifier->notifier_call(notifier, PBOOK_WAKE);
-	}
 	return ret;
 }
 
@@ -2491,15 +2485,13 @@ static void
 pmu_pass_intr(unsigned char *data, int len)
 {
 	struct pmu_private *pp;
-	struct list_head *list;
 	int i;
 	unsigned long flags;
 
 	if (len > sizeof(pp->rb_buf[0].data))
 		len = sizeof(pp->rb_buf[0].data);
 	spin_lock_irqsave(&all_pvt_lock, flags);
-	for (list = &all_pmu_pvt; (list = list->next) != &all_pmu_pvt; ) {
-		pp = list_entry(list, struct pmu_private, list);
+	list_for_each_entry(pp, &all_pmu_pvt, list) {
 		spin_lock(&pp->lock);
 		i = pp->rb_put + 1;
 		if (i >= RB_SIZE)
--- a/drivers/mca/mca-proc.c
+++ b/drivers/mca/mca-proc.c
@@ -184,8 +184,14 @@ void __init mca_do_proc_init(void)
 	struct mca_device *mca_dev;
 
 	proc_mca = proc_mkdir("mca", &proc_root);
-	create_proc_read_entry("pos",0,proc_mca,get_mca_info,NULL);
-	create_proc_read_entry("machine",0,proc_mca,get_mca_machine_info,NULL);
+	node = create_proc_read_entry("pos",0,proc_mca,get_mca_info,NULL);
+	if (!node)
+		printk(KERN_WARNING "MCA: Unable to create mca /proc entry.\n");
+	node = create_proc_read_entry("machine",0,proc_mca,
+		get_mca_machine_info,NULL);
+	if (!node)
+		printk(KERN_WARNING 
+			"MCA: Unable to create machine /proc entry.\n");
 
 	/* Initialize /proc/mca entries for existing adapters */
 
--- a/drivers/media/dvb/bt8xx/dst.c
+++ b/drivers/media/dvb/bt8xx/dst.c
@@ -182,9 +182,11 @@ EXPORT_SYMBOL(dst_pio_disable);
 int dst_wait_dst_ready(struct dst_state *state, u8 delay_mode)
 {
 	u8 reply;
-	int i;
+	int i = 0;
+	unsigned long end_time;
 
-	for (i = 0; i < 200; i++) {
+	end_time = jiffies + msecs_to_jiffies(2000);
+	while (time_before(jiffies, end_time)) {
 		if (dst_gpio_inb(state, &reply) < 0) {
 			dprintk(verbose, DST_ERROR, 1, "dst_gpio_inb ERROR !");
 			return -1;
@@ -194,6 +196,7 @@ int dst_wait_dst_ready(struct dst_state 
 			return 1;
 		}
 		msleep(10);
+		++i;
 	}
 	dprintk(verbose, DST_NOTICE, 1, "dst wait NOT ready after %d", i);
 
--- a/drivers/media/dvb/dvb-usb/dtt200u-fe.c
+++ b/drivers/media/dvb/dvb-usb/dtt200u-fe.c
@@ -105,7 +105,7 @@ static int dtt200u_fe_set_frontend(struc
 				  struct dvb_frontend_parameters *fep)
 {
 	struct dtt200u_fe_state *state = fe->demodulator_priv;
-	int i;
+	unsigned long end_time;
 	fe_status_t st;
 	u16 freq = fep->frequency / 250000;
 	u8 bwbuf[2] = { SET_BANDWIDTH, 0 },freqbuf[3] = { SET_RF_FREQ, 0, 0 };
@@ -125,7 +125,8 @@ static int dtt200u_fe_set_frontend(struc
 	freqbuf[2] = (freq >> 8) & 0xff;
 	dvb_usb_generic_write(state->d,freqbuf,3);
 
-	for (i = 0; i < 30; i++) {
+	end_time = jiffies + msecs_to_jiffies(600);
+	while (time_before(jiffies, end_time)) {
 		msleep(20);
 		dtt200u_fe_read_status(fe, &st);
 		if (st & FE_TIMEDOUT)
--- a/drivers/media/dvb/frontends/nxt2002.c
+++ b/drivers/media/dvb/frontends/nxt2002.c
@@ -159,18 +159,19 @@ static int nxt2002_readreg_multibyte (st
 
 static void nxt2002_microcontroller_stop (struct nxt2002_state* state)
 {
-	u8 buf[2],counter = 0;
+	u8 buf[2];
+	unsigned long end_time;
 	dprintk("%s\n", __FUNCTION__);
 
 	buf[0] = 0x80;
 	i2c_writebytes(state,0x22,buf,1);
 
-	while (counter < 20) {
+	end_time = jiffies + msecs_to_jiffies(200);
+	while (time_before(jiffies, end_time)) {
 		i2c_readbytes(state,0x31,buf,1);
 		if (buf[0] & 0x40)
 			return;
 		msleep(10);
-		counter++;
 	}
 
 	dprintk("Timeout waiting for micro to stop.. This is ok after firmware upload\n");
@@ -188,7 +189,8 @@ static void nxt2002_microcontroller_star
 
 static int nxt2002_writetuner (struct nxt2002_state* state, u8* data)
 {
-	u8 buf,count = 0;
+	u8 buf;
+	unsigned long end_time;
 
 	dprintk("Tuner Bytes: %02X %02X %02X %02X\n",data[0],data[1],data[2],data[3]);
 
@@ -215,12 +217,12 @@ static int nxt2002_writetuner (struct nx
 	buf = 0x80;
 	i2c_writebytes(state,0x21,&buf,1);
 
-	while (count < 20) {
+	end_time = jiffies + msecs_to_jiffies(2000);
+	while (time_before(jiffies, end_time)) {
 		i2c_readbytes(state,0x21,&buf,1);
 		if ((buf & 0x80)== 0x00)
 			return 0;
 		msleep(100);
-		count++;
 	}
 
 	printk("nxt2002: timeout error writing tuner\n");
--- a/drivers/media/dvb/frontends/tda80xx.c
+++ b/drivers/media/dvb/frontends/tda80xx.c
@@ -389,9 +389,10 @@ static void tda80xx_worklet(void *priv)
 
 static void tda80xx_wait_diseqc_fifo(struct tda80xx_state* state)
 {
-	size_t i;
+	unsigned long end_time;
 
-	for (i = 0; i < 100; i++) {
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while (time_before(jiffies, end_time)) {
 		if (tda80xx_readreg(state, 0x02) & 0x80)
 			break;
 		msleep(10);
--- a/drivers/media/dvb/ttpci/av7110.c
+++ b/drivers/media/dvb/ttpci/av7110.c
@@ -1998,7 +1998,7 @@ static int nexusca_stv0297_pll_set(struc
 	u8 data[4];
 	struct i2c_msg msg = { .addr = 0x63, .flags = 0, .buf = data, .len = sizeof(data) };
 	struct i2c_msg readmsg = { .addr = 0x63, .flags = I2C_M_RD, .buf = data, .len = 1 };
-	int i;
+	unsigned long end_time;
 
 	div = (params->frequency + 36150000 + 31250) / 62500;
 
@@ -2024,8 +2024,8 @@ static int nexusca_stv0297_pll_set(struc
 	}
 
 	// wait for PLL lock
-	for(i = 0; i < 20; i++) {
-
+	end_time = jiffies + msecs_to_jiffies(200);
+	while (time_before(jiffies, end_time)) {
 		stv0297_enable_plli2c(fe);
 		if (i2c_transfer(&av7110->i2c_adap, &readmsg, 1) == 1)
 			if (data[0] & 0x40) break;
--- a/drivers/media/dvb/ttpci/budget-av.c
+++ b/drivers/media/dvb/ttpci/budget-av.c
@@ -193,7 +193,7 @@ static int ciintf_slot_reset(struct dvb_
 {
 	struct budget_av *budget_av = (struct budget_av *) ca->data;
 	struct saa7146_dev *saa = budget_av->budget.dev;
-	int timeout = 50; // 5 seconds (4.4.6 Ready)
+	unsigned long end_time;
 
 	if (slot != 0)
 		return -EINVAL;
@@ -211,10 +211,11 @@ static int ciintf_slot_reset(struct dvb_
 
 	/* This should have been based on pin 16 READY of the pcmcia port,
 	 * but AFAICS it is not routed to the saa7146 */
-	while (--timeout > 0 && ciintf_read_attribute_mem(ca, slot, 0) != 0x1d)
+	end_time = jiffies + msecs_to_jiffies(5000); // 5 seconds (4.4.6 Ready)
+	while (time_before(jiffies, end_time) && ciintf_read_attribute_mem(ca, slot, 0) != 0x1d)
 		msleep(100);
 
-	if (timeout <= 0)
+	if (time_after_eq(jiffies, end_time))
 	{
 		printk(KERN_ERR "budget-av: cam reset failed (timeout).\n");
 		saa7146_setgpio(saa, 2, SAA7146_GPIO_OUTHI); /* disable card */
--- a/drivers/media/radio/radio-cadet.c
+++ b/drivers/media/radio/radio-cadet.c
@@ -341,7 +341,7 @@ static ssize_t cadet_read(struct file *f
 	if(rdsin==rdsout) {
   	        if (file->f_flags & O_NONBLOCK)
 		        return -EWOULDBLOCK;
-	        interruptible_sleep_on(&read_queue);
+		wait_event_interruptible(read_queue, rdsin != rdsout);
 	}		
 	while( i<count && rdsin!=rdsout)
 	        readbuf[i++]=rdsbuf[rdsout++];
--- a/drivers/media/video/bttv-driver.c
+++ b/drivers/media/video/bttv-driver.c
@@ -759,7 +759,7 @@ static void set_pll_freq(struct bttv *bt
 
 static void set_pll(struct bttv *btv)
 {
-	int i;
+	unsigned long end_time;
 
 	if (!btv->pll.pll_crystal)
 		return;
@@ -785,7 +785,8 @@ static void set_pll(struct bttv *btv)
 		btv->pll.pll_ifreq, btv->pll.pll_ofreq);
 	set_pll_freq(btv, btv->pll.pll_ifreq, btv->pll.pll_ofreq);
 
-	for (i=0; i<10; i++) {
+	end_time = jiffies + msecs_to_jiffies(100);
+	while (time_before(jiffies, end_time)) {
 		/*  Let other people run while the PLL stabilizes */
 		bttv_printk(".");
 		msleep(10);
--- a/drivers/media/video/c-qcam.c
+++ b/drivers/media/video/c-qcam.c
@@ -91,7 +91,7 @@ static unsigned int qcam_await_ready1(st
 					     int value)
 {
 	unsigned long oldjiffies = jiffies;
-	unsigned int i;
+	unsigned long end_time;
 
 	for (oldjiffies = jiffies; (jiffies - oldjiffies) < (HZ/25); )
 		if (qcam_ready1(qcam) == value)
@@ -99,7 +99,8 @@ static unsigned int qcam_await_ready1(st
 
 	/* If the camera didn't respond within 1/25 second, poll slowly 
 	   for a while. */
-	for (i = 0; i < 50; i++)
+	end_time = jiffies + msecs_to_jiffies(5000);
+	while (time_before(jiffies, end_time))
 	{
 		if (qcam_ready1(qcam) == value)
 			return 0;
@@ -116,7 +117,7 @@ static unsigned int qcam_await_ready1(st
 static unsigned int qcam_await_ready2(struct qcam_device *qcam, int value)
 {
 	unsigned long oldjiffies = jiffies;
-	unsigned int i;
+	unsigned long end_time;
 
 	for (oldjiffies = jiffies; (jiffies - oldjiffies) < (HZ/25); )
 		if (qcam_ready2(qcam) == value)
@@ -124,7 +125,8 @@ static unsigned int qcam_await_ready2(st
 
 	/* If the camera didn't respond within 1/25 second, poll slowly 
 	   for a while. */
-	for (i = 0; i < 50; i++)
+	end_time = jiffies + msecs_to_jiffies(5000);
+	while (time_before(jiffies, end_time))
 	{
 		if (qcam_ready2(qcam) == value)
 			return 0;
--- a/drivers/media/video/cpia.c
+++ b/drivers/media/video/cpia.c
@@ -194,9 +194,6 @@ enum {
 #define DARK_TIME       3
 #define LIGHT_TIME      3
 
-/* Maximum number of 10ms loops to wait for the stream to become ready */
-#define READY_TIMEOUT 100
-
 /* Developer's Guide Table 5 p 3-34
  * indexed by [mains][sensorFps.baserate][sensorFps.divisor]*/
 static u8 flicker_jumps[2][2][4] =
@@ -2830,6 +2827,7 @@ static int fetch_frame(void *data)
 	int image_size, retry;
 	struct cam_data *cam = (struct cam_data *)data;
 	unsigned long oldjif, rate, diff;
+	unsigned long end_time;
 
 	/* Allow up to two bad images in a row to be read and
 	 * ignored before an error is reported */
@@ -2858,10 +2856,10 @@ static int fetch_frame(void *data)
 
 		if (cam->ops->wait_for_stream_ready) {
 			/* loop until image ready */
-			int count = 0;
 			do_command(cam, CPIA_COMMAND_GetCameraStatus,0,0,0,0);
+			end_time = jiffies + msecs_to_jiffies(1000);
 			while (cam->params.status.streamState != STREAM_READY) {
-				if(++count > READY_TIMEOUT)
+				if(time_after(jiffies, end_time))
 					break;
 				if(cam->params.status.streamState ==
 				   STREAM_PAUSED) {
--- a/drivers/media/video/cx88/cx88-core.c
+++ b/drivers/media/video/cx88/cx88-core.c
@@ -753,7 +753,7 @@ static int set_pll(struct cx88_core *cor
 	static u32 pre[] = { 0, 0, 0, 3, 2, 1 };
 	u64 pll;
 	u32 reg;
-	int i;
+	unsigned long end_time;
 
 	if (prescale < 2)
 		prescale = 2;
@@ -771,7 +771,9 @@ static int set_pll(struct cx88_core *cor
 	dprintk(1,"set_pll:    MO_PLL_REG       0x%08x [old=0x%08x,freq=%d]\n",
 		reg, cx_read(MO_PLL_REG), ofreq);
 	cx_write(MO_PLL_REG, reg);
-	for (i = 0; i < 100; i++) {
+
+	end_time = jiffies + msecs_to_jiffies(1000);
+	while (time_before(jiffies, end_time)) {
 		reg = cx_read(MO_DEVICE_STATUS);
 		if (reg & (1<<2)) {
 			dprintk(1,"pll locked [pre=%d,ofreq=%d]\n",
--- a/drivers/media/video/em28xx/em28xx-i2c.c
+++ b/drivers/media/video/em28xx/em28xx-i2c.c
@@ -399,18 +399,6 @@ static u32 functionality(struct i2c_adap
 	return I2C_FUNC_SMBUS_EMUL;
 }
 
-#ifndef I2C_PEC
-static void inc_use(struct i2c_adapter *adap)
-{
-	MOD_INC_USE_COUNT;
-}
-
-static void dec_use(struct i2c_adapter *adap)
-{
-	MOD_DEC_USE_COUNT;
-}
-#endif
-
 static int em28xx_set_tuner(int check_eeprom, struct i2c_client *client)
 {
 	struct em28xx *dev = client->adapter->algo_data;
@@ -481,12 +469,7 @@ static struct i2c_algorithm em28xx_algo 
 };
 
 static struct i2c_adapter em28xx_adap_template = {
-#ifdef I2C_PEC
 	.owner = THIS_MODULE,
-#else
-	.inc_use = inc_use,
-	.dec_use = dec_use,
-#endif
 	.class = I2C_CLASS_TV_ANALOG,
 	.name = "em28xx",
 	.id = I2C_HW_B_EM28XX,
--- a/drivers/media/video/meye.c
+++ b/drivers/media/video/meye.c
@@ -558,15 +558,19 @@ static void mchip_dma_free(void)
    reset the dma engine */
 static void mchip_hic_stop(void)
 {
-	int i, j;
+	unsigned long end_time, end_time2;
 
 	meye.mchip_mode = MCHIP_HIC_MODE_NOOP;
 	if (!(mchip_read(MCHIP_HIC_STATUS) & MCHIP_HIC_STATUS_BUSY))
 		return;
-	for (i = 0; i < 20; ++i) {
+
+	end_time = jiffies + msecs_to_jiffies(7000);
+	while (time_before(jiffies, end_time)) {
 		mchip_set(MCHIP_HIC_CMD, MCHIP_HIC_CMD_STOP);
 		mchip_delay(MCHIP_HIC_CMD, 0);
-		for (j = 0; j < 100; ++j) {
+
+		end_time2 = jiffies + msecs_to_jiffies(100);
+		while (time_before(jiffies, end_time2)) {
 			if (mchip_delay(MCHIP_HIC_STATUS,
 					MCHIP_HIC_STATUS_IDLE))
 				return;
@@ -660,7 +664,7 @@ static int mchip_comp_read_frame(u32 v, 
 /* take a picture into SDRAM */
 static void mchip_take_picture(void)
 {
-	int i;
+	unsigned long end_time;
 
 	mchip_hic_stop();
 	mchip_subsample();
@@ -671,7 +675,8 @@ static void mchip_take_picture(void)
 
 	mchip_delay(MCHIP_HIC_CMD, 0);
 
-	for (i = 0; i < 100; ++i) {
+	end_time = jiffies + msecs_to_jiffies(100);
+	while (time_before(jiffies, end_time)) {
 		if (mchip_delay(MCHIP_HIC_STATUS, MCHIP_HIC_STATUS_IDLE))
 			break;
 		msleep(1);
@@ -683,12 +688,14 @@ static void mchip_get_picture(u8 *buf, i
 {
 	u32 v;
 	int i;
+	unsigned long end_time;
 
 	mchip_set(MCHIP_HIC_MODE, MCHIP_HIC_MODE_STILL_OUT);
 	mchip_set(MCHIP_HIC_CMD, MCHIP_HIC_CMD_START);
 
 	mchip_delay(MCHIP_HIC_CMD, 0);
-	for (i = 0; i < 100; ++i) {
+	end_time = jiffies + msecs_to_jiffies(100);
+	while (time_before(jiffies, end_time)) {
 		if (mchip_delay(MCHIP_HIC_STATUS, MCHIP_HIC_STATUS_IDLE))
 			break;
 		msleep(1);
@@ -724,6 +731,7 @@ static int mchip_compress_frame(u8 *buf,
 {
 	u32 v;
 	int len = -1, i;
+	unsigned long end_time;
 
 	mchip_vrj_setup(0x3f);
 	udelay(50);
@@ -732,7 +740,9 @@ static int mchip_compress_frame(u8 *buf,
 	mchip_set(MCHIP_HIC_CMD, MCHIP_HIC_CMD_START);
 
 	mchip_delay(MCHIP_HIC_CMD, 0);
-	for (i = 0; i < 100; ++i) {
+
+	end_time = jiffies + msecs_to_jiffies(100);
+	while (time_before(jiffies, end_time)) {
 		if (mchip_delay(MCHIP_HIC_STATUS, MCHIP_HIC_STATUS_IDLE))
 			break;
 		msleep(1);
